// stesso sketch di quello precedente ma con l'utilizzo delle funzioni

#include <SPI.h>
#include <Ethernet.h>
#include <TextFinder.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

//const char server[] = "api.wunderground.com"; 
IPAddress server(2,23,104,120); // IP 2,23,104,120 di api.wunderground.com 
IPAddress ip(10,0,3,127);
EthernetClient client;
TextFinder finder( client );
String responseString;
boolean startCapture;
String readString = String(100); 
char buffer_meteo[31]; 
char tempo_oggi[31];
char buffer_domani[31];
int h = 0;
int m = 0;
int s = 0;
int led_sole = 2;
int led_nuvoloso=3;
int led_pioggia=5;
int led_temporale=6;
int led_neve=7;

void setup() {
Serial.begin(9600);
pinMode(led_sole,OUTPUT);
pinMode(led_nuvoloso,OUTPUT);
pinMode(led_pioggia,OUTPUT);
pinMode(led_temporale,OUTPUT);
pinMode(led_neve,OUTPUT);

}

void loop() {
Serial.flush();
 //Serial.print("Orologio");
 
  if (s == 59){
    m++;
    s = 0;
  }
  else
  {
    s++;
  }

 if (m == 60){
    h+=1;
    m = 0;
  }  
  
  if (h == 24){
    h=0;
  } 
  
 
  delay(1000);
   Serial.print(s);  
   Serial.print("-");  
   Serial.println(m); 
   
   if (m==1){
   connessione();
   lettura_meteo();

   m=0;
   }
   
   }






void lettura_meteo(){
 if (client.available())
  {
    char c = client.read();
    if(c == '{')
      startCapture=true;
    
    if(startCapture)
      responseString += c;
  }
  
    if (client.connected())
  {
    


    
    Serial.print("tempo domani:  ");
    if ( finder.find("<period>2</period>") && finder.find ("icon")){
    finder.getString(">","<",buffer_domani,sizeof(buffer_domani));
    char *tempo_domani =buffer_domani;
    Serial.println(tempo_domani);  
 
    }
    
    client.stop();
    client.flush();
    
  }
  }
    
    
    
    
    
    void connessione(){
    if (Ethernet.begin(mac) == 0)
  {
    Serial.println("Failed to configure Ethernet using DHCP");
    Ethernet.begin(mac,ip);
  }
  
  delay(500);
  Serial.print("My IP Address is: ");
  Serial.println(Ethernet.localIP());
  Serial.println("Connecting...");

  if (client.connect(server, 80)) 
  {
    Serial.println("Connected!");
    String richiesta = "GET http://api.wunderground.com/api/f8ac4a22f841d562/conditions/forecast/q/zmw:00000.1.16080.xml HTTP/1.0";
    
    String chiusura_connessione = "Connection: close";

    client.println(richiesta);
    client.println(chiusura_connessione);
    client.println();
    
    responseString = "";
    startCapture = false;   
  } 
  else
  {
   Serial.println("Connection failed!");
  }
  }
 
 
