#include <SPI.h>
#include <Ethernet.h>
#include <TextFinder.h>
#include <Servo.h>

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

//const char server[] = "api.wunderground.com"; 
IPAddress server(2,23,104,120); // IP 2,23,104,120 di api.wunderground.com 
IPAddress ip(10,0,3,127);
EthernetClient client;
TextFinder finder( client );
String responseString;
boolean startCapture;
String readString = String(100); 
char buffer_meteo[31]; 
char tempo_oggi[31];
char buffer_domani[31];
int h = 0;
int m = 0;
int s = 0;
Servo myservo;
int statoMeteo=0;  

void setup() {
Serial.begin(9600);
 myservo.attach(9);
}

void loop() {
Serial.flush();
 //Serial.print("Orologio");
 
  if (s == 59){
    m++;
    s = 0;
  }
  else
  {
    s++;
  }

 if (m == 60){
    h+=1;
    m = 0;
  }  
  
  if (h == 24){
    h=0;
  } 
  
 
  delay(1000);
   Serial.print(s);  
   Serial.print("-");  
   Serial.println(m); 
   if (m==5){
   connessione();
   lettura_meteo();
   m=0;
   }
   else
   {

   }
   }






void lettura_meteo(){
 if (client.available())
  {
    char c = client.read();
    if(c == '{')
      startCapture=true;
    
    if(startCapture)
      responseString += c;
  }
  
    if (client.connected())
  {
      
    
    Serial.print("tempo domani:  ");
    if ( finder.find("<period>2</period>") && finder.find ("icon")){
    finder.getString(">","<",buffer_domani,sizeof(buffer_domani));
    char *tempo_domani =buffer_domani;
    Serial.println(tempo_domani);  
    
    
    //se il tempo è bello o parzialmente nuvoloso. I nomi seguiti da nt_ si riferiscono alle stesse previsioni però di notte
  
     if((strcmp(tempo_domani,"clear")==0)|| (strcmp(tempo_domani,"nt_clear")==0)|| (strcmp(tempo_domani,"partlysunny")==0)|| (strcmp(tempo_domani,"nt_partlysunny")==0)){ 
         if (statoMeteo==0){
         fermo();
         }
         if (statoMeteo==1){
         dietro();
         dietro();
          fermo();
         }
         if (statoMeteo==2){
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
         }
         if (statoMeteo==3){
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
         }
        if (statoMeteo==4){
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
         }
         statoMeteo=0;
     }
     //se il tempo è  nuvoloso 
     if((strcmp(tempo_domani,"cloudy")==0)|| (strcmp(tempo_domani,"nt_cloudy")==0)|| (strcmp(tempo_domani,"partlycloudy")==0)|| (strcmp(tempo_domani,"nt_partlycloudy")==0)||(strcmp(tempo_domani,"mostlycloudy")==0)|| (strcmp(tempo_domani,"nt_mostlycloudy")==0)){  
     if (statoMeteo==0){
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==1){
         fermo();
         }
         if (statoMeteo==2){
         dietro();
         dietro();
          fermo();
         }
         if (statoMeteo==3){
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
         }
        if (statoMeteo==4){
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
        }
         statoMeteo=1;
         
     }
     //se piove 
     if((strcmp(tempo_domani,"chancesleet")==0)|| (strcmp(tempo_domani,"nt_chancesleet")==0)|| (strcmp(tempo_domani,"chancerain")==0)|| (strcmp(tempo_domani,"nt_chancerain")==0)){ 
     if (statoMeteo==0){
         avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==1){
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==2){
         fermo();
         }
         if (statoMeteo==3){
         dietro();
         dietro();
          fermo();
         }
        if (statoMeteo==4){
         dietro();
         dietro();
         dietro();
         dietro();
          fermo();
        }
         statoMeteo=2;
         
       
       
    }
     //se c'è un temporale 
     if((strcmp(tempo_domani,"chancetstorms")==0)|| (strcmp(tempo_domani,"nt_chancetstorms")==0)){  
    if (statoMeteo==0){
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==1){
         avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==2){
        avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==3){
          fermo();
         }
        if (statoMeteo==4){
         dietro();
         dietro();
          fermo();
         
        }
         statoMeteo=3;
  
    }
    //se c'è nevica 
     if((strcmp(tempo_domani,"chanceflurries")==0)|| (strcmp(tempo_domani,"nt_chanceflurries")==0)){ 
     if (statoMeteo==0){
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==1){
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==2){
        avanti();
         avanti();
         avanti();
         avanti();
          fermo();
         }
         if (statoMeteo==3){
          avanti();
         avanti();
          fermo();
         }
        if (statoMeteo==4){
         fermo();
         
        }
         statoMeteo=4;
  
       
    }
     
     
     
    }
    
    client.stop();
    client.flush();
    
  }
  }
    
    
    
    
    
    void connessione(){
    if (Ethernet.begin(mac) == 0)
  {
    Serial.println("Failed to configure Ethernet using DHCP");
    Ethernet.begin(mac,ip);
  }
  
  delay(500);
  Serial.print("My IP Address is: ");
  Serial.println(Ethernet.localIP());
  Serial.println("Connecting...");

  if (client.connect(server, 80)) 
  {
    Serial.println("Connected!");
    String richiesta = "GET http://api.wunderground.com/api/f8ac4a22f841d562/conditions/forecast/q/zmw:00000.1.16080.xml HTTP/1.0";
    
    String chiusura_connessione = "Connection: close";

    client.println(richiesta);
    client.println(chiusura_connessione);
    client.println();
    
    responseString = "";
    startCapture = false;   
  } 
  else
  {
   Serial.println("Connection failed!");
  }
  }
  
  
void avanti(){
myservo.write(0);
delay(1000);
}
  
void fermo(){
myservo.write(90);
}

void dietro(){
myservo.write(180);
delay(1060);
}

 
